#!/usr/bin/env python

#
# RNAspace: non-coding RNA annotation platform
# Copyright (C) 2009  CNRS, INRA, INRIA, Univ. Paris-Sud 11
# 
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# 
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
# 
# You should have received a copy of the GNU General Public License
# along with this program.  If not, see <http://www.gnu.org/licenses/>.
#

"""
**** WHAT DOES THE SCRIPT ****

Convert a fasta database in rnaspace compliant one.
The script :
  - convert the comment line of each sequence. When the input is frnadb,
    some families are converted into rfam ones. The new comment is in the form:

    ><family>|<sequence>|<comment>
    where:
    <family> : Name of the RNA family - max 20 characters
    <sequence> : description of the sequence - max 50 characters
    <comment> : free fields - max 100 characters 

  - compute max shift for blast/yass.
  - execute a formatdb.

All generated files can be directly copied in your rnaspace databases 
directory.


**** GENERATED FILES ****

For each database, 5 files are generated:
    - <database>_<version>.fasta: the database  with converted comment lines
    - <database>_<version>.fasta_cluster.txt: file use for the blast/yass 
                                              merging
    - <database>_<version>.fasta.{nhr,nin,nsq}: files generated by formatdb

When used against frnadb, the script will convert some family names into
rfam ones. In this case, a log file is generated:
    <database>_<version>.log : contains all the information about 
                               the conversions


**** FAMILY CONVERSION ****

The frnadb family names are converted to the corresponding rfam ones according
to the file `rfam_families.txt` except for families that are in the file
`excluded_families.txt`. 

The file `rfam_families.txt` contains the correspondance between rfam ids 
and family names.
The file 'excluded_families.txt' contains rfam family ids that differs from
rfam 8.1 to rfam 9.1.


**** USAGE EXAMPLES ****

To convert rfam database, you can run the script with ths command:
./convert_database.py -d Rfam_9.1 rfam.fasta

It will create a directory named 'database' and will put all the generated files
in it.

You can specify the output directory by placing it at the end of the line:
./convert_database.py -d Rfam_9.1 rfam.fasta my_directory

You can also specify the formatdb path with the -f option:
./convert_database.py -d Rfam_9.1 -f /usr/bin/formatdb rfam.fasta my_directory


**** SUPPORTED DATABASES ****

Supported databases are:
  - Rfam_9.1 
  - fRNAdb_3.0 
  - miRBase_13.0
"""

import os
from optparse import OptionParser

# default output directory
DEFAULT_OUTDIR = "database"

# characters that are forbidden in a field of the fasta comment line
FORBIDDEN = ['\n', '|', '>']
# size limit for each field of the fasta comment line
FAMILY_LIMIT = 20
SEQUENCE_LIMIT = 50
COMMENT_LIMIT = 100
# default values for begin/end fields
# DEFAULT_BEGIN = 0
# DEFAULT_END = 0

# Different paths
EXCLUDED_FILE = os.path.join(os.path.dirname(__file__),
                             "excluded_families.txt")
RFAM_FAMILIES_FILE = os.path.join(os.path.dirname(__file__),
                                  "rfam_families.txt")

def get_opt_parser():    
    usage = "usage: %prog -d DATABASE [options] infile [outdir]"
    usage += "\n\toutdir is '%s' by default"%DEFAULT_OUTDIR
    parser = OptionParser(usage=usage)
    parser.add_option("-d", "--dbname",
                      action="store",
                      type="choice",
                      dest="input",
                      help="database ['fRNAdb_3.0', 'Rfam_9.1', 'Rfam_10.0', 'miRBase_13.0', testdb_1.0]",
                      metavar="DATABASE",
                      choices=["fRNAdb_3.0", "Rfam_9.1", "Rfam_10.0",
                               "miRBase_13.0", "testdb_1.0"],
                      default=None)
    parser.add_option("-f", "--format-db",
                      action="store",
                      dest="format_db",
                      help="format_db path",
                      metavar="FORMAT_DB",
                      default="/usr/bin/formatdb")
    parser.add_option("-c", "--compact-log",
                      action="store_true",
                      dest="compact_log",
                      help="write less information in log",
                      default=False)
    return parser

class Conversion():
    """
    Manage a family conversion table
    """
    def __init__(self, dbname, path):
        """
        Initialisation
        
        Arguments:
        - `dbname`: the name of the database
        - `path`: the path where to write conversion table
        """
        self.tab = {}
        self.dbname = dbname
        self.path = path

    def add(self, original, new, line):
        """
        Add a correspondance in the conversion tab
        
        Arguments:
        - `original`: the name of the original family
        - `new`: the name of the new family
        - `line`: the line number where original family is
        """
        self.tab.setdefault(original, [])
        self.tab[original].append((new, line))

    def write(self, compact):
        if compact:
            self.write_compact_tab()
        else:
            self.write_tab()

    def write_tab(self):
        """
        Write the correspondance table in a file
        """        
        if len(self.tab) == 0:
            return
        ftab = open(self.path, "w")
        for (original, new) in self.tab.iteritems():
            for (i, (family, line_num)) in enumerate(new):
                l = "%s of %s (line %i) => %s\n"%(original, self.dbname,
                                                  line_num, family)
                ftab.write(l)
        ftab.close()
        print "**INFO: some families has been converted"
        print "**INFO: conversion table written in %s" % self.path

    def write_compact_tab(self):
        """
        Write the correspondance table in a file with a compact form
        """
        compact_tab = {}
        if len(self.tab) == 0:
            return
        # create a more compact table
        for (original, new) in self.tab.iteritems():
            compact_tab.setdefault(original, [])
            for (i, (family, line_num)) in enumerate(new):
                if family not in compact_tab[original]:
                    compact_tab[original].append(family)

        # write it in a file
        ftab = open(self.path, "w")
        for (original, new) in compact_tab.iteritems():
            line = ""
            for (i, family) in enumerate(new):
                if i % 4 == 0 and i !=0:
                    line += "\n" + " "*(len(original) + 4)
                line += "'%s', " % (family)
            ftab.write("%s = %s\n" % (original, "[" + line + "]"))
        ftab.close()
        print "**INFO: some families has been converted"
        print "**INFO: conversion table written in %s" % self.path

def rfam_families():
    """
    Load the file `RFAM_FAMILIES_FILE` in a dictionary and return it.

    If the file `EXCLUDED_FILE` exists, then all families it contained
    are deleted from the returned dictionary.
    """
    if not os.path.isfile(RFAM_FAMILIES_FILE):
        print "too bad"
        return {}

    if os.path.isfile(EXCLUDED_FILE):
        excluded = []
        fexcluded = open(EXCLUDED_FILE, "r")
        for line in fexcluded:
            excluded.append(line.replace("\n", ""))
        fexcluded.close()
    else:
        print "too bad1"
        excluded = []

    families = {}
    frfam = open(RFAM_FAMILIES_FILE, "r")
    for line in frfam:
        splitted = line.split('=')
        if splitted[0] not in excluded:
            families[splitted[0]] = splitted[1].replace('\n', '')
    return families

def remove_forbidden_chars(line):
    """
    Remove forbidden chars in the line
    
    Arguments:
    - `line`: the string we want to remove forbidden chars from
    """
    l = line
    for char in FORBIDDEN:
        l = l.replace(char, '_')
    return l

def fRNAdb_3_0_header(header, rfam, conversion, line):
    """
    Extract different fields in a frnadb header and convert family names
    according to the `rfam` dictionary if an rfam id is present in the 
    comment line.

    old comment line:
    >FR000001|AB027356|Group II intron|group_II_intron|RF00029 Rfam 
    v8.1|Cordyceps sp. 97009|75nt

    new comment line:
    >group_II_intron|AB027356/Cordyceps sp. 97009|FR000001/Group II   
    intron/RF00029 Rfam v8.1/75nt

    if `RF00029` is in the rfam directory, then `group_II_intron` is converted
    to the corresponding rfam family name

    Retrun tuple: (family, seq_car, comment)
    
    Arguments:
    - `header`: the comment line of a frnadb sequence
    - `rfam`: dictionary=> keys:rfam ids, values: family names
    - `conversion`: Conversion instance
    - `line`: line number of the comment line
    """
    try:
        splitted = header.split('|')
        # family
        try:
            rfamid = splitted[4].split()[0]
            if rfamid in rfam:
                family = rfam[rfamid]
                conversion.add(splitted[3], family, line)
            else:
                family = splitted[3]        
        except:
            family = splitted[3]
        family = family[:FAMILY_LIMIT]
        family = remove_forbidden_chars(family)
        # sequence caracterisation
        seq_car = "%s/%s" % (splitted[1], splitted[5])
        seq_car = seq_car[:SEQUENCE_LIMIT]
        seq_car = remove_forbidden_chars(seq_car)
        # begin/end
        # begin = DEFAULT_BEGIN
        # end = DEFAULT_END
        # comment
        comment = "%s/%s/%s/%s" % (splitted[0][1:], splitted[2], splitted[4],
                                   splitted[6][:-1])
        comment = comment[:COMMENT_LIMIT]
        comment = remove_forbidden_chars(comment)
    except:
        print "infile is not a frnadb database"
        exit(1)

    return (family, seq_car, comment)
    
def Rfam_9_1_header(header, conversion, line):
    """
    Extract different fields in a rfam header

    old comment line:
    >CP000300.1/2148545-2148621  RF00029;Intron_gpII;

    new comment line
    >Intron_gpII|CP000300.1/2148545-2148621|RF00029  

    Retrun tuple: (family, seq_car, comment)
    
    Arguments:
    - `header`: the comment line of a rfam sequence
    - `conversion`: Conversion instance
    - `line`: line number of the comment line
    """
    try:
        splitted = header.split()
        # family 
        family = splitted[1].split(';')[1]
        family = family[:FAMILY_LIMIT]
        family = remove_forbidden_chars(family)
        # sequence caracterisation
        seq_car = splitted[0]
        seq_car = seq_car[1:SEQUENCE_LIMIT]
        seq_car = remove_forbidden_chars(seq_car)
        # begin/end
        # begin = splitted[0].split('/')[1].split('-')[0]
        # end = splitted[0].split('/')[1].split('-')[1]
        # comment        
        comment = splitted[1].split(';')[0]
        comment = comment[:COMMENT_LIMIT]
        comment = remove_forbidden_chars(comment)
    except:
        print "infile is not a rfam database"
        exit(1)
    return (family, seq_car, comment)

def Rfam_10_0_header(header, conversion, line):
    """
    Extract different fields in a rfam header

    old comment line:
    >RF00001;5S_rRNA;DQ397844.1/16860-16979   414005:Cenarchaeum symbiosum B

    new comment line
    >5S_rRNA|DQ397844.1/16860-16979   414005:Cenarchaeum symbiosum B_|RF00001

    Retrun tuple: (family, seq_car, comment)
    
    Arguments:
    - `header`: the comment line of a rfam sequence
    - `conversion`: Conversion instance
    - `line`: line number of the comment line
    """
    try:
        splitted = header.split(';')
        # family
        family = splitted[1]
        family = family[:FAMILY_LIMIT]
        family = remove_forbidden_chars(family)
        # sequence caracterisation
        seq_car = splitted[2]
        seq_car = seq_car[1:SEQUENCE_LIMIT]
        seq_car = remove_forbidden_chars(seq_car)
        # comment        
        comment = splitted[0][1:]
        comment = comment[:COMMENT_LIMIT]
        comment = remove_forbidden_chars(comment)
    except:
        print "infile is not a rfam database"
        exit(1)
    return (family, seq_car, comment)

def miRBase_13_0_header(header, conversion, line):
    """
    Extract different fields in a mirna header

    old comment line:
    >cel-let-7 MI0000001 Caenorhabditis elegans let-7 stem-loop

    new comment line:
    >miRNA|unknown|cel-let-7 MI0000001 Caenorhabditis elegans let-7 stem-loop

    Retrun tuple: (family, seq_car, comment)
    
    Arguments:
    - `header`: the comment line of a mirna sequence
    - `conversion`: Conversion instance
    - `line`: line number of the comment line
    """
    comment = header[1:-1]
    comment = comment[:COMMENT_LIMIT]
    comment = remove_forbidden_chars(comment)
    return ("miRNA", "unknown", comment)

def get_header_fields(header, db_name, conversion, line, rfam=None):
    if db_name == "Rfam_9.1" or db_name == "testdb_1.0":
        return Rfam_9_1_header(header, conversion, line)
    if db_name == "Rfam_10.0":
        return Rfam_10_0_header(header, conversion, line)
    if db_name == "fRNAdb_3.0":
        return fRNAdb_3_0_header(header, rfam, conversion, line)
    if db_name == "miRBase_13.0":
        return miRBase_13_0_header(header, conversion, line)

def convert_db(infile, formatted_db, dbname, conv_path, log_mode, rfam=None):
    """
    Convert the db represented by infile and write it in formatted_db
    
    Arguments:
    - `infile`: the path to the database we want to convert
    - `formatted_db`: the new path of the database
    """
    finfile = open(infile, "r")
    fres = open(formatted_db, "w")
    conv = Conversion(dbname, conv_path)
    for (i, line) in enumerate(finfile):
        if line.startswith('>'):
            (family, seq_car, comment) = get_header_fields(line, dbname, conv,
                                                           i+1, rfam)
            fres.write(">%s|%s|%s\n" % (family, seq_car, comment))
        else:
            fres.write(line)
    fres.close()
    finfile.close()
    conv.write(log_mode)

def compute_d(formatted_db, cluster_path):
    """    
    Arguments:
    - `formatted_db`: path to the formatted database
    """
    finfile = open(formatted_db, "r")
    first_line = True
    families = {}
    family = ""
    seq_length = 0

    # get the sequences lengths for each family and store them in a dictionary:
    # keys are the family names and values are a list of length
    for line in finfile:
        if line.startswith('>'):
            if not first_line:
                families.setdefault(family, [])
                families[family].append(seq_length)
            else:
                first_line = False
            splitted = line.split('|')
            family = splitted[0][1:]
            seq_length = 0
        else:
            seq_length += len(line.replace('\n', ''))

    # get the min/max length for each family
    d_list = {}
    for family in families:
        min_seq = min(families[family])
        max_seq = max(families[family])
        # and compute d
        d_list[family] = long(max(max_seq-min_seq, max_seq/4))
    d_list_sorted = d_list.keys()
    d_list_sorted.sort()
    
    fresult = open(cluster_path, "w")
    for family in d_list_sorted:
        fresult.write(family + "=" + str(d_list[family]) + "\n")
    fresult.close()

def main():
    parser = get_opt_parser()
    (opts, args) = parser.parse_args()

    # some tests on input file and arguments
    if len(args) == 1:
        infile = args[0]
        outdir = DEFAULT_OUTDIR
    elif len(args) == 2:
        infile = args[0]
        outdir = args[1]
    else:
        parser.print_help()
        parser.error("Please specify infile and/or outdir")

    if not os.path.isfile(infile):
        parser.error("infile does not exists")

    if opts.input is None:
        parser.print_help()
        parser.error("Please specify -d option ")
    if not os.path.isfile(opts.format_db):
        parser.print_help()
        parser.error(opts.format_db + " does not exist")

    if opts.input == "fRNAdb_3.0":
        rfam = rfam_families()
    else:
        rfam = None

    
    # create all the necessary file paths and directory
    (in_basename, ext) = os.path.splitext(os.path.basename(infile))
    out_basename = opts.input
    formatted_db = os.path.join(outdir, out_basename + ".fasta")
    cluster_path = os.path.join(outdir, out_basename + ".fasta_cluster.txt")
    conv_path = os.path.join(outdir, out_basename + ".log")
    if not os.path.isdir(outdir):
        os.mkdir(outdir)

    # convert the database with rnaspace compliant comment lines
    print "converting database..."
    convert_db(infile, formatted_db, opts.input, conv_path, opts.compact_log,
               rfam)
    # compute the max shift for blast/yass merging
    print "compute d..."
    compute_d(formatted_db, cluster_path)
    # launch a formatdb on the new database
    formatdb = "%s -i %s -p F"%(opts.format_db, formatted_db)
    print formatdb
    os.system(formatdb)
    # diff between old database and new one excluding the comment lines
    diff = 'diff -I "^>" %s %s 1>/dev/null 2>/dev/null'%(infile, formatted_db)
    print diff
    retcode = os.system(diff)
    if retcode != 0:
        print "Error"
    else:
        print "Ok\n"
    
if __name__ == "__main__":
    main()
